-- stm32f4-timers.ads
--
-- just covers timers 6 & 7 for now

pragma Restrictions (No_Elaboration_Code);

package STM32F4.Timer is

   type TIM_Register is record
      CR1     : Word;       --  mode register
      CR2     : Word;
      Res1    : Word;
      DIER    : Word;
      SR      : Word;
      EGR     : Word;
      Res2    : Word;
      Res3    : Word;
      Res4    : Word;
      CNT     : HWord;
      CNT_res : HWord;
      PSC     : HWord;
      PSC_res : HWord;
      ARR     : HWord;
      ARR_res : HWord;
   end record;

   -- check endian-ness for HWords!
   for TIM_Register use record
      CR1     at 0  range 0 .. 31;
      CR2     at 4  range 0 .. 31;
      Res1    at 8  range 0 .. 31;
      DIER    at 12 range 0 .. 31;
      SR      at 16 range 0 .. 31;
      EGR     at 20 range 0 .. 31;
      Res2    at 24 range 0 .. 31;
      Res3    at 28 range 0 .. 31;
      Res4    at 32 range 0 .. 31;
      CNT     at 36 range 0 .. 15;
      CNT_res at 38 range 0 .. 15;
      PSC     at 40 range 0 .. 15;
      PSC_res at 42 range 0 .. 15;
      ARR     at 44 range 0 .. 15;
      ARR_res at 46 range 0 .. 15;
   end record;

   -- CR1 constants
   CEN  : constant Word := 16#01#;
   UDIS : constant Word := 16#02#;
   URS  : constant Word := 16#04#;
   OPM  : constant Word := 16#08#;
   ARPE : constant Word := 16#80#;

   -- CR2 constants
   MMS_Update : constant Word := 2#0010_0000#;
   MMS_Enable : constant Word := 2#0001_0000#;
   MMS_Reset  : constant Word := 2#0000_0000#;

   -- DIER constants
   UIE : constant Word := 16#0_01#;
   UDE : constant Word := 16#1_00#;

   -- SR constants
   UIF : constant Word := 1;

   -- EGR constants
   UG : constant Word := 1;


end STM32F4.Timer;
